VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CProtect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const ALG_TYPE_ANY As Long = 0
Private Const ALG_CLASS_HASH As Long = 32768
Private Const ALG_TYPE_BLOCK As Long = 1536
Private Const ALG_CLASS_DATA_ENCRYPT As Long = 24576
Private Const ALG_SID_RC2 As Long = 2
Private Const ALG_SID_SHA1 As Long = 4
' Hash algorithms
Private Const CALG_SHA1 As Long = ALG_CLASS_HASH Or ALG_TYPE_ANY Or ALG_SID_SHA1
' Block ciphers
Private Const CALG_RC2 As Long = ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_BLOCK Or ALG_SID_RC2
Private Const PROV_RSA_AES As Long = 24
Private Const ALG_SID_AES_128 As Long = 14
Private Const CALG_AES_128 As Long = ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_BLOCK Or ALG_SID_AES_128

' CryptSetProvParam
Private Const PROV_RSA_FULL As Long = 1
' used when aquiring the provider
Private Const CRYPT_VERIFYCONTEXT As Long = &HF0000000
' Microsoft provider data
Private Const MS_DEFAULT_PROVIDER As String = _
"Microsoft Base Cryptographic Provider v1.0"
' used to specify not to use any salt value while deriving the key
Private Const CRYPT_NO_SALT As Long = &H10
Private Const CRYPT_EXPORTABLE As Long = 1
Private Const CRYPT_NEWKEYSET As Long = 8

Private Declare Function CryptHashData Lib "advapi32.dll" (ByVal hHash As Long, ByVal pbData As String, ByVal dwDataLen As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptCreateHash Lib "advapi32.dll" (ByVal hProv As Long, ByVal algid As Long, ByVal hKey As Long, ByVal dwFlags As Long, ByRef phHash As Long) As Long
Private Declare Function CryptDestroyHash Lib "advapi32.dll" (ByVal hHash As Long) As Long
Private Declare Function CryptAcquireContext Lib "advapi32.dll" Alias "CryptAcquireContextA" (ByRef phProv As Long, ByVal pszContainer As String, ByVal pszProvider As String, ByVal dwProvType As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptReleaseContext Lib "advapi32.dll" (ByVal hProv As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptDeriveKey Lib "advapi32.dll" (ByVal hProv As Long, ByVal algid As Long, ByVal hBaseData As Long, ByVal dwFlags As Long, ByRef phKey As Long) As Long
Private Declare Function CryptDestroyKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function CryptDecrypt Lib "advapi32.dll" (ByVal hKey As Long, ByVal hHash As Long, ByVal Final As Long, ByVal dwFlags As Long, ByRef pbData As Any, pdwDataLen As Long) As Long

Private Const E_FAIL = &H80004005
Private m_hProvider As Long
Private m_hHash As Long
Private m_hKey As Long


Private Sub Class_Initialize()
    m_hProvider = 0
    m_hHash = 0
    m_hKey = 0
End Sub

Private Sub Class_Terminate()
    ReleaseKey
End Sub

Private Sub ReleaseKey()
    If m_hKey Then
        CryptDestroyKey (m_hKey)
        m_hKey = 0
    End If
    If m_hHash Then
        CryptDestroyHash (m_hHash)
        m_hHash = 0
    End If
    If m_hProvider Then
        CryptReleaseContext m_hProvider, 0
        m_hProvider = 0
    End If
End Sub

Private Function UpdateKey(ByVal szKey As String) As Long
    If Len(szKey) <> 16 Then
        UpdateKey = E_FAIL
        Exit Function
    End If
    
    ReleaseKey
    
    Dim lRet As Long
    lRet = 1
    szKey = LCase(szKey)
    lRet = 0
    If CBool(CryptAcquireContext(m_hProvider, vbNullString, vbNullString, PROV_RSA_AES, 0)) = True Then
goodcontext:
        If CBool(CryptCreateHash(m_hProvider, CALG_SHA1, 0, 0, m_hHash)) = True Then
            If CBool(CryptHashData(m_hHash, StrConv(szKey, vbUnicode), Len(szKey) * 2, 0)) = True Then
                If CBool(CryptDeriveKey(m_hProvider, CALG_AES_128, m_hHash, CRYPT_EXPORTABLE, m_hKey)) = True Then
                    UpdateKey = 0
                    Exit Function
                End If
            End If
        End If
    Else
        If CBool(CryptAcquireContext(m_hProvider, vbNullString, vbNullString, PROV_RSA_AES, CRYPT_NEWKEYSET)) = True Then
            GoTo goodcontext
        End If
    End If
    UpdateKey = E_FAIL
End Function

Public Function Decrypt(ByVal szKey As String, ByRef pData() As Byte, ByRef dwSize As Long) As Long
    Dim lResult As Long
    lResult = UpdateKey(szKey)
    If lResult = 0 Then
        If CBool(CryptDecrypt(m_hKey, 0, 1, 0, pData(0), dwSize)) = True Then
            ReDim Preserve pData(dwSize)
            Decrypt = 0
            Exit Function
        End If
    Else
        Decrypt = lResult
        Exit Function
    End If
    Decrypt = Err.LastDllError
End Function
